---
title: Features restricted to secure contexts
slug: Web/Security/Secure_Contexts/features_restricted_to_secure_contexts
tags:
  - API
  - Browsers
  - Reference
  - Secure contexts
  - Security
  - Web
  - features
  - support
---
<p>This reference lists the web platform features available only in secure contexts — see <a href="/en-US/docs/Web/Security/Secure_Contexts">Secure Contexts</a> for a definition and more details.</p>

<h2 id="Current_features_available_only_in_secure_contexts">Current features available only in secure contexts</h2>

<p>This section lists all the APIs available only in secure contexts, along with browser versions the limitation was introduced in, as appropriate.</p>

<div class="note">
<p><strong>Note</strong>: Only the browsers that actually support secure contexts are listed in this document. <a href="/en-US/docs/Web/Security/Secure_Contexts#Browser_compatibility">See here</a> for information on secure contexts support.</p>
</div>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">API</th>
   <th scope="col">Chrome/Opera</th>
   <th scope="col">Edge</th>
   <th scope="col">Safari</th>
   <th scope="col">Firefox</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Web/API/Clipboard">Async Clipboard API</a></td>
   <td>66</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>63</td>
  </tr>
  <tr>
   <td><a href="https://wicg.github.io/BackgroundSync/spec/">Background Sync</a> (see {{domxref("SyncManager")}}, for example)</td>
   <td>49</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>Not supported</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/HTTP/Headers/Cache-Control"><code>Cache-Control: immutable</code></a></td>
   <td>Not supported</td>
   <td>15</td>
   <td>11</td>
   <td>49</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Credential_Management_API">Credential Management API</a></td>
   <td>51</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>Not supported</td>
  </tr>
  <tr>
   <td><a href="https://w3c.github.io/sensors/">Generic Sensor API</a></td>
   <td>67</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>Not supported</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> (and <a href="https://w3c.github.io/payment-method-basic-card/">Basic Card Payment</a>).</td>
   <td>61</td>
   <td><a href="https://blogs.windows.com/msedgedev/2017/04/11/introducing-edgehtml-15/">15</a></td>
   <td><a href="https://webkit.org/blog/8182/introducing-the-payment-request-api-for-apple-pay/">11.1</a></td>
   <td>In development (behind the <code>dom.payments.request.enabled</code> pref).</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Push_API">Push API</a></td>
   <td>42</td>
   <td><a href="https://blogs.windows.com/msedgedev/2017/12/19/service-workers-going-beyond-page/">17</a></td>
   <td>Not supported</td>
   <td>44</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Reporting_API">Reporting API</a></td>
   <td>Supported</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>Behind flag since Fx 65</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Service_Worker_API">Service Workers</a></td>
   <td>40</td>
   <td><a href="https://blogs.windows.com/msedgedev/2017/12/19/service-workers-going-beyond-page/">17</a></td>
   <td><a href="https://webkit.org/blog/8216/new-webkit-features-in-safari-11-1/">11.1</a></td>
   <td>44</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Storage_API">Storage API</a></td>
   <td>55</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>51</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Web_Authentication_API">Web Authentication API</a></td>
   <td>65</td>
   <td><a href="https://blogs.windows.com/msedgedev/2018/07/30/introducing-web-authentication-microsoft-edge/">In preview (17)</a></td>
   <td><a href="https://bugs.webkit.org/show_bug.cgi?id=181943">In development</a></td>
   <td>60</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Web_Bluetooth_API">Web Bluetooth</a></td>
   <td>56</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>Not supported</td>
  </tr>
  <tr>
   <td><a href="https://webaudio.github.io/web-midi-api/">Web MIDI</a> (see {{domxref("MIDIAccess")}}, for example)</td>
   <td>43</td>
   <td>Not supported</td>
   <td>Not supported</td>
   <td>Not supported</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API </a></td>
   <td>60</td>
   <td>79</td>
   <td>Not supported</td>
   <td>75</td>
  </tr>
 </tbody>
</table>

<h2 id="Secure_context_restrictions_that_vary_by_browser">Secure context restrictions that vary by browser</h2>

<p>Some browsers may decide to disable certain APIs in non-secure contexts or apply other restrictions/security measures, despite the spec not requiring them. This section lists any such differences existing in browsers.</p>

<table class="standard-table">
 <thead>
  <tr>
   <th>API</th>
   <th>Chrome</th>
   <th>Edge</th>
   <th>Safari</th>
   <th>Firefox</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a href="/en-US/docs/Web/HTML/Using_the_application_cache">Application Cache</a></td>
   <td><a href="https://bugs.chromium.org/p/chromium/issues/detail?id=588931#c19">Restricted to secure contexts from Chrome 70</a> (complete removal planned for Chrome 90).</td>
   <td>Restricted to secure contexts from Edge 79 (removal planned for Edge 90).</td>
   <td><a href="https://twitter.com/johnwilander/status/959423900470800384">public interest on deprecation</a> {{webkitbug(182442)}}</td>
   <td><a href="https://www.fxsitecompat.com/en-CA/docs/2018/application-cache-can-no-longer-be-used-on-insecure-sites/">Restricted to secure contexts in Firefox 62</a> (complete removal from Firefox 84).</td>
  </tr>
  <tr>
   <td>{{domxref("Geolocation")}}</td>
   <td><a href="https://developers.google.com/web/updates/2016/04/geolocation-on-secure-contexts-only">Restricted to secure contexts in 50</a></td>
   <td></td>
   <td>Restricted to secure contexts in 10</td>
   <td><a href="https://www.fxsitecompat.com/en-CA/docs/2017/use-of-geolocation-api-is-now-limited-to-secure-sites/">Restricted to secure contexts in 55</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Detecting_device_orientation">Device Orientation / Device Motion</a></td>
   <td>Deprecation warning</td>
   <td></td>
   <td></td>
   <td><a href="https://www.fxsitecompat.com/en-CA/docs/2018/various-device-sensor-apis-are-now-deprecated/">Deprecation warnings since 60</a>. Note that these apply to secure contexts as well.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Encrypted_Media_Extensions_API">Encrypted Media Extensions</a></td>
   <td><a href="https://developers.google.com/web/updates/2017/03/chrome-58-deprecations#remove_eme_from_non-secure_contexts">Restricted to secure contexts in 58</a></td>
   <td></td>
   <td></td>
   <td><a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1322517">Planned</a>.</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/MediaDevices/getUserMedia">getUserMedia()</a></td>
   <td><a href="https://developers.google.com/web/updates/2015/10/chrome-47-webrtc">Restricted to secure contexts in Chrome 47</a></td>
   <td></td>
   <td></td>
   <td>Temporary access available only (users cannot choose "Remember this decision" in the permission request dialog).<br>
    <br>
    <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1335740">Restricted to secure contexts in Firefox 68.</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Notifications_API">Notifications</a></td>
   <td><a href="https://developers.google.com/web/updates/2017/09/chrome-62-deprecations#remove_usage_of_notifications_from_insecure_iframes">Restricted to secure contexts in Chrome 62</a></td>
   <td></td>
   <td></td>
   <td><a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1429432">Restricted to secure contexts in Firefox 67.</a></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/HTML/Element/a#attr-ping">&lt;a ping&gt; attribute</a></td>
   <td></td>
   <td>Disabled in non-secure contexts</td>
   <td></td>
   <td>Support has been added since Firefox 3, but never been enabled by default (behind the <code>browser.send_pings</code> pref).</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Presentation_API">Presentation</a></td>
   <td><a href="https://developers.google.com/web/updates/2017/08/chrome-61-deprecations#deprecate_and_remove_presentation_api_on_insecure_contexts">Deprecation warning in 61</a></td>
   <td></td>
   <td></td>
   <td></td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API</a></td>
   <td>Has been restricted to HTTPS since early days (API was visible in HTTP as well but operations failed). <a href="https://developers.google.com/web/updates/2017/06/chrome-60-deprecations#cryptosubtle_now_requires_a_secure_origin">Restricted to secure contexts in Chrome 60</a> (API is no longer visible on non-secure contexts).</td>
   <td>Restricted to secure contexts from Edge 79</td>
   <td></td>
   <td>Restricted to secure contexts in Firefox 75</td>
  </tr>
  <tr>
   <td><a href="/en-US/docs/Web/API/Navigator/registerProtocolHandler">registerProtocolHandler()</a></td>
   <td></td>
   <td></td>
   <td></td>
   <td><a href="https://www.fxsitecompat.com/en-CA/docs/2018/navigator-registerprotocolhandler-can-no-longer-be-used-on-insecure-sites/">Restricted to secure contexts in Firefox 62</a>.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Security/Secure_Contexts">Secure contexts</a></li>
 <li><a href="https://www.fxsitecompat.dev/en-CA/categories/privacy-security/">Privacy &amp; Security section on Firefox Site Compatibility</a></li>
 <li><a href="https://www.chromestatus.com/features#secure%20context">"secure context" query on Chrome Platform Status</a></li>
</ul>

<div>{{QuickLinksWithSubpages("/en-US/docs/Web/Security")}}</div>
